'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ContextMenuPopup = function (_React$Component) {
	_inherits(ContextMenuPopup, _React$Component);

	function ContextMenuPopup() {
		_classCallCheck(this, ContextMenuPopup);

		var _this = _possibleConstructorReturn(this, (ContextMenuPopup.__proto__ || Object.getPrototypeOf(ContextMenuPopup)).call(this));

		_this.state = {
			optionsVisible: false
		};
		return _this;
	}

	_createClass(ContextMenuPopup, [{
		key: 'componentDidUpdate',
		value: function componentDidUpdate() {
			this.boundClickCallback = this.boundClickCallback || this.close.bind(this);

			if (this.state.optionsVisible) {
				document.addEventListener('click', this.boundClickCallback);
			} else {
				document.removeEventListener('click', this.boundClickCallback);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var Trigger = this.getTriggerElement();
			var OptionsList = this.getOptionsListElement();

			return _react2.default.createElement(
				'div',
				{ className: this.getClassName(), style: this.getStyles() },
				Trigger,
				this.state.optionsVisible ? OptionsList : null
			);
		}
	}, {
		key: 'getStyles',
		value: function getStyles() {
			var required = {
				position: 'relative'
			};

			if (this.props.style) {
				Object.assign(required, this.props.style);
			}

			return required;
		}
	}, {
		key: 'getClassName',
		value: function getClassName() {
			return this.props.className || 'context-menu-popup';
		}
	}, {
		key: 'getTriggerElement',
		value: function getTriggerElement() {
			var Trigger = _react2.default.Children.toArray(this.props.children).filter(function (item) {
				if (item && item.type && item.type.name === 'ContextMenuPopupTrigger') {
					return item;
				}
			})[0];

			return _react2.default.cloneElement(Trigger, {
				customOnClickHandler: Trigger.props.onClick,
				onClick: this.onTriggerClick.bind(this),
				contextMenuPopup: this
			});
		}
	}, {
		key: 'onTriggerClick',
		value: function onTriggerClick() {
			this.setState({
				optionsVisible: true
			});
		}
	}, {
		key: 'getOptionsListElement',
		value: function getOptionsListElement() {
			var OptionsList = _react2.default.Children.toArray(this.props.children).filter(function (item) {
				if (item && item.type && item.type.name === 'ContextMenuPopupOptions') {
					return item;
				}
			})[0];

			return _react2.default.cloneElement(OptionsList, {
				onMouseLeave: this.onOptionsListMouseLeave.bind(this),
				initialStyles: this.props.initialStyles,
				contextMenuPopup: this
			});
		}
	}, {
		key: 'close',
		value: function close() {
			this.setState({
				optionsVisible: false
			});
		}
	}, {
		key: 'open',
		value: function open() {
			this.setState({
				optionsVisible: true
			});
		}
	}, {
		key: 'onOptionsListMouseLeave',
		value: function onOptionsListMouseLeave() {
			this.setState({
				optionsVisible: false
			});
		}
	}]);

	return ContextMenuPopup;
}(_react2.default.Component);

exports.default = ContextMenuPopup;