'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// import classNames from 'classnames';

var styles = {
	padding: '10px',
	whiteSpace: 'nowrap',
	cursor: 'pointer'
};

var hoverStyles = {
	backgroundColor: 'rgb(207, 207, 207)'
};

var ContextMenuPopupOption = function (_React$Component) {
	_inherits(ContextMenuPopupOption, _React$Component);

	/* istanbul ignore next */
	function ContextMenuPopupOption() {
		_classCallCheck(this, ContextMenuPopupOption);

		var _this = _possibleConstructorReturn(this, (ContextMenuPopupOption.__proto__ || Object.getPrototypeOf(ContextMenuPopupOption)).call(this));

		_this.state = {
			hovered: false
		};
		return _this;
	}

	_createClass(ContextMenuPopupOption, [{
		key: 'render',
		value: function render() {
			return _react2.default.createElement(
				'div',
				{
					className: this.getClassName(),
					style: this.getStyle(),
					onMouseEnter: this.onMouseEnter.bind(this),
					onMouseLeave: this.onMouseLeave.bind(this),
					onClick: this.handleOptionClick.bind(this)
				},
				this.props.children
			);
		}
	}, {
		key: 'getClassName',
		value: function getClassName() {
			return this.props.className || 'context-menu-popup__option';
		}
	}, {
		key: 'handleOptionClick',
		value: function handleOptionClick() {
			if (this.props.onOptionSelect) {
				this.props.onOptionSelect(this.props.id, this.props.contextMenuPopup);
			} else {
				this.props.onClick(this.props.contextMenuPopup);
			}
		}
	}, {
		key: 'onMouseEnter',
		value: function onMouseEnter() {
			this.setState({
				hovered: true
			});
		}
	}, {
		key: 'onMouseLeave',
		value: function onMouseLeave() {
			this.setState({
				hovered: false
			});
		}
	}, {
		key: 'getStyle',
		value: function getStyle() {
			var _props = this.props,
			    style = _props.style,
			    hoverStyle = _props.hoverStyle,
			    initialStyles = _props.initialStyles;
			var hovered = this.state.hovered;


			if (style && !hovered) {
				return style;
			}

			if (style && hovered) {
				return Object.assign({}, style, hoverStyle);
			}

			if (!initialStyles) {
				return {};
			}

			if (hovered) {
				return Object.assign({}, styles, hoverStyles);
			}

			return styles;
		}
	}]);

	return ContextMenuPopupOption;
}(_react2.default.Component);

exports.default = ContextMenuPopupOption;