'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var requiredStyles = {
	position: 'absolute',
	top: 0,
	left: 0
};

var styles = {
	boxShadow: '0 0 5px #c7c7c7',
	background: 'white',
	opacity: 0,
	zIndex: 1
};

var ContextMenuPopupOptions = function (_React$Component) {
	_inherits(ContextMenuPopupOptions, _React$Component);

	function ContextMenuPopupOptions() {
		_classCallCheck(this, ContextMenuPopupOptions);

		return _possibleConstructorReturn(this, (ContextMenuPopupOptions.__proto__ || Object.getPrototypeOf(ContextMenuPopupOptions)).apply(this, arguments));
	}

	_createClass(ContextMenuPopupOptions, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			this.align();

			var children = _react2.default.Children.map(this.props.children, function (child, index) {
				return _react2.default.cloneElement(child, {
					contextMenuPopup: _this2.props.contextMenuPopup,
					onOptionSelect: _this2.props.onOptionSelect,
					initialStyles: _this2.props.initialStyles,
					key: index
				});
			});

			return _react2.default.createElement(
				'div',
				{
					className: this.getClassName(),
					ref: 'options',
					onMouseLeave: this.props.onMouseLeave,
					style: this.getStyles() },
				children
			);
		}
	}, {
		key: 'getClassName',
		value: function getClassName() {
			return this.props.className || 'context-menu-popup__options';
		}
	}, {
		key: 'align',
		value: function align() {
			var _this3 = this;

			setTimeout(function () {
				var options = _this3.refs.options;


				if (options.getBoundingClientRect().right > window.innerWidth) {
					options.style.left = '';
					options.style.right = '0';
				}

				if (options.getBoundingClientRect().bottom > window.innerHeight) {
					options.style.top = '';
					options.style.bottom = '0';
				}

				options.style.opacity = 1;
			}, 1);
		}
	}, {
		key: 'getStyles',
		value: function getStyles() {
			var props = this.props;


			if (props.style) {
				return Object.assign({}, requiredStyles, props.style);
			}

			if (!props.initialStyles) {
				return requiredStyles;
			}

			return Object.assign({}, requiredStyles, styles);
		}
	}]);

	return ContextMenuPopupOptions;
}(_react2.default.Component);

exports.default = ContextMenuPopupOptions;